{#-#####################################################################
 # Jinja2 template for /etc/rc.conf.d/netif
 #======================================================================
 # Common helper macros
 ####################################################################-#}
{#-=====================================================================
 # macro get_interface_gateway_address
 #======================================================================
 #
 # Return the IP address of the default gateway bound to the specified
 # interface, if any.
 #
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should try to echo a default
 #      gateway address.
 #
 #  - protocol (str, optional)
 #      Accepted values: ['inet4', 'inet6']
 #      The type of IP address to echo. 
 #===================================================================-#}
{%- macro get_interface_gateway_address(interface, protocol='inet4') -%}
  {%- set default_gateways = [] -%}
  {%- set default_gateway_addresses = [] -%}

  {#- Get default routes -#}
  {%-   if protocol == 'inet4' -%}
    {%- set default_routes = my_network_routes |
        selectattr('destination', 'equalto', '0.0.0.0/0') -%}
  {%- elif protocol == 'inet6' -%}
    {%- set default_routes = my_network_routes |
        selectattr('destination', 'equalto', '::0/0') -%}
  {%- endif -%}

  {#- Get gateways bound to the specified interface -#}
  {%- for default_route in default_routes -%}
    {%- set default_gateway =
      my_network_gateways
      | selectattr('uid', 'equalto', default_route['gateway'])
      | first
    -%}
    {%- if default_gateway['interface'] == interface['uid'] -%}
      {{ default_gateways.append(default_gateway) }}
    {%- endif -%}
  {%- endfor -%}

  {#- Filter default gateways by protocol type -#}
  {%- for gateway in default_gateways -%}
    {%- if protocol == 'inet4' -%}
      {%- if protocol in gateway['addresses']
         and gateway['addresses'][protocol] | ipv4('address')
      -%}
        {{
          default_gateway_addresses.append(
            gateway['addresses'][protocol])
        }}
      {%- endif -%}
    {%- elif protocol == 'inet6' -%}
      {%- if protocol in gateway['addresses']
         and gateway['addresses'][protocol] | ipv6('address')
      -%}
        {%- set address =
              gateway['addresses'][protocol] | ipv6('address') -%}
        {#- We need to add the gateway interface as a suffix to
         #  link-local IPv6 addresses! -#}
        {%- if address | ipv6('fe80/10') -%}
          {%- set gateway_interface =
                my_network_interfaces[gateway['interface']] -%}
          {%- set gateway_interface_name =
                get_interface_name(gateway_interface) -%}
          {%- set address = address ~ '%' ~ gateway_interface_name -%}
        {%- endif -%}
        
        {{ default_gateway_addresses.append(address) }}
      {%- endif -%}
    {%- endif -%}
  {%- endfor -%}

  {#- Return the address of the first default gateway found, if any -#}
  {%- if default_gateway_addresses -%}
    {{ default_gateway_addresses | first }}
  {%- endif -%}
{%- endmacro -%}

{#-=====================================================================
 # macro get_interface_inet_addresses
 #======================================================================
 #
 # Echoes a list of IP address definitions assigned to the specified
 # interface. Definitions are returned as a JSON-encoded list.
 #
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The interface for which the macro should echo a list of IP
 #      assigned address definitions.
 #
 #  - protocol (str, optional)
 #      Accepted values: ['inet4', 'inet6']
 #      The type of IP address to search for. Default is to return
 #      inet4 addresses.
 #===================================================================-#}
{%- macro get_interface_inet_addresses(interface, protocol='inet4') -%}
  {%- set inet_addresses = [] -%}

  {%- for inet_address in my_network_addresses -%}
    {%- if inet_address['interface'] == interface['uid'] -%}
      {%- if inet_address['protocol'] == protocol -%}
        {{ inet_addresses.append(inet_address) }}
      {%- endif -%}
    {%- endif -%}
  {%- endfor -%}

  {{ inet_addresses | to_json }}
{%- endmacro -%}

{#-=====================================================================
 # macro get_interface_name
 #======================================================================
 #
 # Return the native or final name of the supplied interface definition.
 #
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The network interface to process.
 #
 #  - native (bool)
 #      If set to ``true``, returns the native interface name before
 #      interface renaming takes place.
 #===================================================================-#}
{%- macro get_interface_name(interface, native=false) -%}
  {#- Build native names -#}
  {%-   if interface['type'] == 'adapter' -%}
    {%- set interface_name = interface['adapter']['device'] -%}
  {%- elif interface['type'] == 'bond' -%}
    {%- set interface_name = 'lagg' ~ interface['bond']['index'] -%}
  {%- elif interface['type'] == 'bridge' -%}
    {%- set interface_name = 'bridge' ~ interface['bridge']['index'] -%}
  {%- elif interface['type'] == 'vlan' -%}
    {%- set interface_name = 'vlan' ~ interface['vlan']['index'] -%}
  {%- endif -%}

  {#- Replace native name with custom name, if needed -#}
  {%- if native == false -%}
    {%- if 'name' in interface -%}
      {%- set interface_name = interface['name'] -%}
    {%- endif -%}
  {%- endif -%}

  {#- Echo interface name -#}
  {{ interface_name }}
{%- endmacro -%}

{#-=====================================================================
 # macro get_interface_names_from_uids
 #======================================================================
 #
 # Return the native or final names of all interfaces supplied as a list
 # of interface uids. The final list is echoed back as a JSON string.
 #
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface_uids (str[])
 #      A list of network interface unique identifiers.
 #
 #  - native (bool)
 #      If set to ``true``, returns native interface names before
 #      interface renaming takes place.
 #===================================================================-#}
{%- macro get_interface_names_from_list(interface_uids, native=false)-%}
  {%- set interface_names = [] -%}
  {%- for interface_uid in interface_uids -%}
    {%- set interface = my_network_interfaces
      | selectattr('uid', 'equalto', interface_uid) | first -%}
    {{ interface_names.append(get_interface_name(interface, native)) }}
  {%- endfor -%}
  {{ interface_names | to_json }}
{%- endmacro -%}